diff --git a/drivers/clk/mediatek/clk-mt8188-adsp_audio26m.c b/drivers/clk/mediatek/clk-mt8188-adsp_audio26m.c
index b3c31ffff931..808f2ad3b7ee 100644
--- a/drivers/clk/mediatek/clk-mt8188-adsp_audio26m.c
+++ b/drivers/clk/mediatek/clk-mt8188-adsp_audio26m.c
@@ -4,10 +4,12 @@
  * Author: Garmin Chang <garmin.chang@mediatek.com>
  */
 
-#include <dt-bindings/clock/mediatek,mt8188-clk.h>
 #include <linux/clk-provider.h>
+#include <linux/mod_devicetable.h>
 #include <linux/platform_device.h>
 
+#include <dt-bindings/clock/mediatek,mt8188-clk.h>
+
 #include "clk-gate.h"
 #include "clk-mtk.h"
 
@@ -34,7 +36,7 @@ static const struct of_device_id of_match_clk_mt8188_adsp_audio26m[] = {
 	{ .compatible = "mediatek,mt8188-adsp-audio26m", .data = &adsp_audio26m_desc },
 	{ /* sentinel */ }
 };
-MODULE_DEVICE_TABLE(platform, of_match_clk_mt8188_adsp_audio26m);
+MODULE_DEVICE_TABLE(of, of_match_clk_mt8188_adsp_audio26m);
 
 static struct platform_driver clk_mt8188_adsp_audio26m_drv = {
 	.probe = mtk_clk_simple_probe,
diff --git a/drivers/clk/mediatek/clk-mt8188-imp_iic_wrap.c b/drivers/clk/mediatek/clk-mt8188-imp_iic_wrap.c
index 2238d2984320..da41a3c59919 100644
--- a/drivers/clk/mediatek/clk-mt8188-imp_iic_wrap.c
+++ b/drivers/clk/mediatek/clk-mt8188-imp_iic_wrap.c
@@ -4,10 +4,12 @@
  * Author: Garmin Chang <garmin.chang@mediatek.com>
  */
 
-#include <dt-bindings/clock/mediatek,mt8188-clk.h>
 #include <linux/clk-provider.h>
+#include <linux/mod_devicetable.h>
 #include <linux/platform_device.h>
 
+#include <dt-bindings/clock/mediatek,mt8188-clk.h>
+
 #include "clk-gate.h"
 #include "clk-mtk.h"
 
@@ -65,7 +67,7 @@ static const struct of_device_id of_match_clk_mt8188_imp_iic_wrap[] = {
 	{ .compatible = "mediatek,mt8188-imp-iic-wrap-en", .data = &imp_iic_wrap_en_desc },
 	{ /* sentinel */ }
 };
-MODULE_DEVICE_TABLE(platform, of_match_clk_mt8188_imp_iic_wrap);
+MODULE_DEVICE_TABLE(of, of_match_clk_mt8188_imp_iic_wrap);
 
 static struct platform_driver clk_mt8188_imp_iic_wrap_drv = {
 	.probe = mtk_clk_simple_probe,
diff --git a/drivers/clk/mediatek/clk-mt8188-vdo0.c b/drivers/clk/mediatek/clk-mt8188-vdo0.c
index 0c61c2dc4337..d2be44c2f3f5 100644
--- a/drivers/clk/mediatek/clk-mt8188-vdo0.c
+++ b/drivers/clk/mediatek/clk-mt8188-vdo0.c
@@ -4,10 +4,12 @@
  * Author: Garmin Chang <garmin.chang@mediatek.com>
  */
 
-#include <dt-bindings/clock/mediatek,mt8188-clk.h>
 #include <linux/clk-provider.h>
+#include <linux/mod_devicetable.h>
 #include <linux/platform_device.h>
 
+#include <dt-bindings/clock/mediatek,mt8188-clk.h>
+
 #include "clk-gate.h"
 #include "clk-mtk.h"
 
diff --git a/drivers/clk/mediatek/clk-mt8188-vdo1.c b/drivers/clk/mediatek/clk-mt8188-vdo1.c
index 99fcf6d7b1ab..2ef8cae2e16e 100644
--- a/drivers/clk/mediatek/clk-mt8188-vdo1.c
+++ b/drivers/clk/mediatek/clk-mt8188-vdo1.c
@@ -4,10 +4,12 @@
  * Author: Garmin Chang <garmin.chang@mediatek.com>
  */
 
-#include <dt-bindings/clock/mediatek,mt8188-clk.h>
 #include <linux/clk-provider.h>
+#include <linux/mod_devicetable.h>
 #include <linux/platform_device.h>
 
+#include <dt-bindings/clock/mediatek,mt8188-clk.h>
+
 #include "clk-gate.h"
 #include "clk-mtk.h"
 
diff --git a/drivers/clk/mediatek/clk-mt8188-venc.c b/drivers/clk/mediatek/clk-mt8188-venc.c
index 6f6589ccd5a0..245367f33fa5 100644
--- a/drivers/clk/mediatek/clk-mt8188-venc.c
+++ b/drivers/clk/mediatek/clk-mt8188-venc.c
@@ -4,10 +4,12 @@
  * Author: Garmin Chang <garmin.chang@mediatek.com>
  */
 
-#include <dt-bindings/clock/mediatek,mt8188-clk.h>
 #include <linux/clk-provider.h>
+#include <linux/mod_devicetable.h>
 #include <linux/platform_device.h>
 
+#include <dt-bindings/clock/mediatek,mt8188-clk.h>
+
 #include "clk-gate.h"
 #include "clk-mtk.h"
 
@@ -39,7 +41,7 @@ static const struct of_device_id of_match_clk_mt8188_venc1[] = {
 	{ .compatible = "mediatek,mt8188-vencsys", .data = &venc1_desc },
 	{ /* sentinel */ }
 };
-MODULE_DEVICE_TABLE(platform, of_match_clk_mt8188_venc1);
+MODULE_DEVICE_TABLE(of, of_match_clk_mt8188_venc1);
 
 static struct platform_driver clk_mt8188_venc1_drv = {
 	.probe = mtk_clk_simple_probe,
diff --git a/drivers/clk/mediatek/clk-mt8188-wpe.c b/drivers/clk/mediatek/clk-mt8188-wpe.c
index 5abded13cece..c372ff703f9c 100644
--- a/drivers/clk/mediatek/clk-mt8188-wpe.c
+++ b/drivers/clk/mediatek/clk-mt8188-wpe.c
@@ -88,7 +88,7 @@ static const struct of_device_id of_match_clk_mt8188_wpe[] = {
 	{ .compatible = "mediatek,mt8188-wpesys-vpp0", .data = &wpe_vpp0_desc },
 	{ /* sentinel */ }
 };
-MODULE_DEVICE_TABLE(platform, clk_mt8188_vpp1_id_table);
+MODULE_DEVICE_TABLE(platform, of_match_clk_mt8188_wpe);
 
 static struct platform_driver clk_mt8188_wpe_drv = {
 	.probe = mtk_clk_simple_probe,